# EDGE DB

## Makefile for deb making

### Environment based on git

MYBRANCH, MYMAJOR, MYMINOR, MYRELEASE, MYREVISION

Depends on  _git name-rev --name-only HEAD_

* MYBRANCH = master : revision name = stable-{MYMAJOR}.{MYMINOR}.{MYRELEASE}
* MYBRANCH = develop : last tagged revision name = stable-{MYMAJOR}.{MYMINOR}.{MYRELEASE}
* MYBRANCH = testing : revision name = testing-{MYMAJOR}.{MYMINOR}.{MYRELEASE}
* MYBRANCH = working : we are in the working fork, not in production reposistory
* MYREVISION = _git log --pretty=format:'%H' -n 1_

### External environment

* VER_DIST = [personal, stable, unstable, testing], default = personal
* VER_MAJOR : default = MYMAJOR
* VER_MINOR : default = MYMINOR
* VER_RELEASE : default = MYRELEASE
* VER_BUILD : default = 0
* VER_RC : default = 0

### Constraints

* stable requires master
* unstable requires develop
* testing requires testing

### Targets

#### whoami

Prints the working copy status info.

###$ whereami

Uses to discovery the latest stable tag from the upstream of working fork.
Hardcoded reference to the BitBucket API.

#### testbranch

_For develop branch:_

* calculate next minor value (Y)
* fill .version.xxx
* commit with comment "Branch testing-X.Y.0"
* make branch testing-X.Y.0
* push

_For master branch:_

* calculate next release value (Z)
* fill .version.xxx
* commit as Branch testing-X.Y.Z
* make branch testing-X.Y.Z

#### stabletag

_For testing branch only!_

* merge testing to master
* delete testing branch
* push
* create tag stable-X.Y.Z
* push

### all

Make deb package with 

* full name = "Edge Builder"
* email = "edge@vitcompany.com"
* deploy directory = ./deploy/(package name)/
* generated changelog

### clean

* debclean
* remove debian/changelog
* remove deploy directory




