import os, sys, json, datetime

from edgedb import *


if len(sys.argv) < 4:
	print("Usage: %s <imagename> <metaname> <preset>" % (argv[0]))
	sys.exit(0)

_if = sys.argv[1]
_mf = sys.argv[2]
preset = sys.argv[3]

with open(_if, 'rb') as imagefile:
	image = imagefile.read()

with open(_mf, 'rt') as metafile:
	meta = json.load(metafile)

if not 'rect' in meta:
	print("Meta should contain RECT")
	sys.exit(0)

titledata = {
	"postnamegd": "TEST POST # 000011",
	"moment": datetime.datetime.now().isoformat(),
	"speedext": "10(70)"
}

subrects = [meta['rect']]

e = EimageProcessor()


res = e.make(image, meta['rect'], preset, titledata, subrects, lang='en')

_of,_ = os.path.splitext(_if)

with open(_of+"."+preset+".jpeg","wb") as imagefile:
	imagefile.write(res['data'])

with open(_of+"."+preset+".json","wt") as metafile:
	json.dump({k: v for k, v in res.iteritems() if not k == 'data'},metafile,indent=4)


