CREATE OR REPLACE FUNCTION core._count_t() RETURNS trigger AS
$$
begin
        if TG_OP = 'INSERT' then
                EXECUTE 'insert into core.relcounting values(''' || TG_TABLE_SCHEMA || ''',''' || TG_TABLE_NAME || ''',1);';
				if random() > 0.75 then perform core._relcount(); end if;
                return NEW;
        elsif TG_OP = 'DELETE' then     
                EXECUTE 'insert into core.relcounting values(''' || TG_TABLE_SCHEMA || ''',''' || TG_TABLE_NAME || ''',-1);';
				if random() > 0.75 then perform core._relcount(); end if;
                return OLD;
        end if;
end;
$$ LANGUAGE plpgsql;

create or replace function core._relcount() returns void as $$
declare
	r record;
begin
	begin
		lock table core.relcounting nowait;
		for r in select * from core.relcount loop
			if r.relnumber > 1 then
				delete from core.relcounting where relschema = r.relschema and relname = r.relname;
				insert into core.relcounting values(r.relschema,r.relname,r.reltuples);
			end if;
		end loop;
	exception when others then
		return;
	end;
end;
$$ language plpgsql;
