CREATE or replace FUNCTION lib.bytea_export(p_source bytea, p_path text) RETURNS integer
    LANGUAGE plpgsql
    AS $$
declare
	lo		oid;
	fd		integer;
	dsize	integer;
	wsize	integer;
begin
	lo := lo_creat(-1);
	fd := lo_open(lo,131072);
	if fd < 0 then
		raise exception 'Inconsistent LO open';
		return -1;
	end if;	
	dsize := lowrite(fd,p_source);
	wsize := lo_export(lo,p_path);
	perform lo_close(fd);
	perform lo_unlink(lo);
	if wsize < 1 then
		raise exception 'Inconsistent LO export: % to %', dsize, wsize;
		return -1;
	end if;	
	return dsize;
end;
$$;
