CREATE or replace FUNCTION lib.bytea_save(bytes bytea, filepath text) RETURNS integer
    LANGUAGE plpythonu
    AS $$
import os

try:
    if bytes is None:
        if os.path.exists(filepath):
            os.unlink(filepath)
        return 0
    oldumask = os.umask(0)
    with open(filepath, 'wb') as f:
        f.write(bytes)
    os.umask(oldumask)
except Exception as ex:
    return -1
return len(bytes)
$$;
