delete from public.filterclass where class = any(array['factlist','listplatear_asc','listplatear_desc', 'listplatear_db', 'listplatear_dbrev']);

insert into public.filterclass (class,returns,paramdef,exec,template,prel,pkey,ptype,pord,memo)values
	('factlist' 				-- classname
	,'table ( scrollid bigint, fact json ) '		-- return type
	,'{
		"fromts": { "type":"long", "constraint":"fromts>0", "mandatory":"False" },
		"tots": { "type":"long", "constraint":"tots>0", "mandatory":"False" },
		"postchannel": { "type":"json", "format":"{uuid:[int,],}" },
		"number": { "type":"string" },
		"distance": { "type":"int" },
		"alarms": { "type":"int" },
		"fromspeed": {"type":"int" },
		"tospeed": {"type":"int" }
	}'::json					-- parameter definition
	,E'
import re	
fromtime = "''-infinity''::timestamptz" if not "fromts" in locals() else "lib.us2ts(%s)" % (fromts)
totime   = "''infinity''::timestamptz"  if not "tots"   in locals() else "lib.us2ts(%s)" % (tots)
postchannelfilter = ""
if "postchannel" in locals():
\tfor _p, _c in postchannel.iteritems():
\t\tpostchannelfilter += " or ( pt.post = ''%s'' " % (_p)
\t\tpostchannelfilter += ("and pt.channel = any(array[" +",".join((str(__c) for __c in _c))+"]::int[])") if len(_c) > 0 else ""
\t\tpostchannelfilter += ") "
postchannelfilter = " ( false " + postchannelfilter + ") " if len(postchannelfilter) > 0 else " true "
if not "number" in locals():
\tnumberfilter = "true"
else:
\tregex=number
\tif "distance" in locals() and distance > 0:
\t\tnumberfilter = " lib.ilevenstein(pt.number,''%s'') <= %d " % (number,distance)
\telse:
\t\tif re.search("[\\[\\]\^\\$\\.\\+\\*\\?]",number):
\t\t\tregex = regex.replace("*",".*")
\t\t\tif not re.search("^\\^",regex): regex = "^"+regex
\t\t\tif not re.search("\\$$",regex): regex = regex+"$"
\t\t\tnumberfilter = " pt.number ~* ''%s'' " % (regex)
\t\telse:
\t\t\tnumberfilter = " pt.number = ''%s'' " % (number)
speedfilter = ""
if "fromspeed" in locals(): speedfilter += " and pt.velocity >= %d " % (fromspeed)
if "tospeed" in locals(): speedfilter += " and pt.velocity <= %d " % (tospeed)
speedfilter = "( true " + speedfilter + ") " if len(speedfilter) > 0 else " true "
alarmfilter = " true " if not "alarms" in locals() else (" pt.alarm_type = 0 " if alarms == 0 else (" pt.alarm_type & %d > 0 " % (alarms)))
'		-- execute
	,'select  
	pt.scrollid,
	to_json(pt.*,true,true,true) as fact
	from platear pt 
	where 
		{postchannelfilter} and 
		pt.ctime >= {fromtime} and pt.ctime < {totime} and 		
		{numberfilter} and 
		{speedfilter} and 
		{alarmfilter} and 
		{__filter[filter]} 
		order by {__filter[order]} limit {__filter[limit]}
	'		-- template
	,'public.platear'			-- primary key relation
	,'scrollid'					-- primary key
	,'bigint'					-- pkey type
	,'asc'						-- pkey sort 
	,'Platear scrollable filter')
;	

insert into public.filterclass (class,returns,paramdef,exec,template,prel,pkey,ptype,pord,memo)values
	('listplatear_asc' 				-- classname
	,'table ( 
		id bigint,
        ctime timestamptz,
		guid uuid,
		scrollid bigint,
		media_id bigint,
		lane integer,
		direction integer,
		velocity integer,
		speedlimit integer,
		vehicle_length integer,
		number text,
		validity integer,
		rect_left float8,
		rect_top float8,
		rect_right float8,
		rect_bottom float8,
		country integer,
		numtype integer,
		geodata json,
		alarmtypes json
	) '		-- return type
	,'{
		"postchannel": { "type":"json", "format":"{uuid:[int,],}" },
		"number": { "type":"string" },
		"distance": { "type":"int" },
		"alarms": { "type":"[string]" },
		"fromspeed": {"type":"int" },
		"tospeed": {"type":"int" }
	}'::json					-- parameter definition
	,E'
import re, json	
postchannelfilter = ""
if "postchannel" in locals():
\tfor _p, _c in postchannel.iteritems():
\t\tpostchannelfilter += " or ( pt.post_id = ''%s'' " % (_p)
\t\tpostchannelfilter += ("and pt.channel = any(array[" +",".join((str(__c) for __c in _c))+"]::int[])") if len(_c) > 0 else ""
\t\tpostchannelfilter += ") "
postchannelfilter = " ( false " + postchannelfilter + ") " if len(postchannelfilter) > 0 else " true "
if not "number" in locals() or not number or number == "":
\tnumberfilter = "true"
else:
\tregex=number
\tif "distance" in locals() and distance > 0:
\t\tnumberfilter = " lib.ilevenstein(pt.number,''%s'') <= %d " % (number,distance)
\telse:
\t\tif re.search("[\\[\\]\^\\$\\.\\+\\*\\?]",number):
\t\t\tregex = regex.replace("*",".*")
\t\t\tif not re.search("^\\^",regex): regex = "^"+regex
\t\t\tif not re.search("\\$$",regex): regex = regex+"$"
\t\t\tnumberfilter = " pt.number ~* ''%s'' " % (regex)
\t\telse:
\t\t\tnumberfilter = " pt.number = ''%s'' " % (number)
speedfilter = ""
if "fromspeed" in locals() and fromspeed and fromspeed >= 0: speedfilter += " and pt.velocity >= %d " % (fromspeed)
if "tospeed" in locals() and tospeed and tospeed >= 0: speedfilter += " and pt.velocity <= %d " % (tospeed)
speedfilter = "( true " + speedfilter + ") " if len(speedfilter) > 0 else " true "
if not "alarms" in locals() or not alarms or len(alarms) == 0:
\talarmfilter = " true "
else:
\trv = plpy.execute("select json_object_agg(name, value) as alist from ( select name, value from public.const_integer where section = ''mask.issue.type'' union all values (''_none'' , 0),(''_any'' , -1) )q",1)
\tif rv.nrows() < 1: raise Exception("Error on issue mask list")
\talist = json.loads(rv[0]["alist"])
\talarmfilter = " ( false "
\tfor a in alarms:
\t\tif a in alist:
\t\t\tmask = alist[a]
\t\t\tif mask == 0: alarmfilter += " or alarm_type = 0 "
\t\t\telif mask == -1: alarmfilter += " or alarm_type > 0 "
\t\t\telse: alarmfilter += " or (alarm_type & %s) = %s " % (mask,mask)
\talarmfilter += " ) "
'		-- execute
	,'select  
		id,
        ctime,
		guid,
		scrollid,
		media_id,
		lane,
		direction,
		velocity,
		velocity - int0 as speedlimit,
		vehicle_length,
		number,
		validity,
		rect_left,
		rect_top,
		rect_right,
		rect_bottom,
		country,
		numtype,
		to_json(geodata) as geodata,
		lib.jstrbit(alarm_type,8,''mask.issue.type'',null) as alarmtypes
	from platear pt 
	where 
		{postchannelfilter} and 
		{numberfilter} and 
		{speedfilter} and 
		{alarmfilter} and 
		{__filter[filter]} 
		order by {__filter[order]} limit {__filter[limit]}
	'		-- template
	,'public.platear'			-- primary key relation
	,'scrollid'					-- primary key
	,'bigint'					-- pkey type
	,'asc'						-- pkey sort 
	,'Platear scrollable on scrollid asc')
;

insert into public.filterclass (class,returns,paramdef,exec,template,prel,pkey,ptype,pord,memo)values
	('listplatear_desc' 				-- classname
	,'table ( 
		id bigint,
        ctime timestamptz,
		guid uuid,
		scrollid bigint,
		media_id bigint,
		lane integer,
		direction integer,
		velocity integer,
		speedlimit integer,
		vehicle_length integer,
		number text,
		validity integer,
		rect_left float8,
		rect_top float8,
		rect_right float8,
		rect_bottom float8,
		country integer,
		numtype integer,
		geodata json,
		alarmtypes json
	) '		-- return type
	,'{
		"postchannel": { "type":"json", "format":"{uuid:[int,],}" },
		"number": { "type":"string" },
		"distance": { "type":"int" },
		"alarms": { "type":"[string]" },
		"fromspeed": {"type":"int" },
		"tospeed": {"type":"int" }
	}'::json					-- parameter definition
	,E'
import re, json	
postchannelfilter = ""
if "postchannel" in locals():
\tfor _p, _c in postchannel.iteritems():
\t\tpostchannelfilter += " or ( pt.post_id = ''%s'' " % (_p)
\t\tpostchannelfilter += ("and pt.channel = any(array[" +",".join((str(__c) for __c in _c))+"]::int[])") if len(_c) > 0 else ""
\t\tpostchannelfilter += ") "
postchannelfilter = " ( false " + postchannelfilter + ") " if len(postchannelfilter) > 0 else " true "
if not "number" in locals() or not number or number == "":
\tnumberfilter = "true"
else:
\tregex=number
\tif "distance" in locals() and distance > 0:
\t\tnumberfilter = " lib.ilevenstein(pt.number,''%s'') <= %d " % (number,distance)
\telse:
\t\tif re.search("[\\[\\]\^\\$\\.\\+\\*\\?]",number):
\t\t\tregex = regex.replace("*",".*")
\t\t\tif not re.search("^\\^",regex): regex = "^"+regex
\t\t\tif not re.search("\\$$",regex): regex = regex+"$"
\t\t\tnumberfilter = " pt.number ~* ''%s'' " % (regex)
\t\telse:
\t\t\tnumberfilter = " pt.number = ''%s'' " % (number)
speedfilter = ""
if "fromspeed" in locals() and fromspeed and fromspeed >= 0: speedfilter += " and pt.velocity >= %d " % (fromspeed)
if "tospeed" in locals() and tospeed and tospeed >= 0: speedfilter += " and pt.velocity <= %d " % (tospeed)
speedfilter = "( true " + speedfilter + ") " if len(speedfilter) > 0 else " true "
if not "alarms" in locals() or not alarms or len(alarms) == 0:
\talarmfilter = " true "
else:
\trv = plpy.execute("select json_object_agg(name, value) as alist from ( select name, value from public.const_integer where section = ''mask.issue.type'' union all values (''_none'' , 0),(''_any'' , -1) )q",1)
\tif rv.nrows() < 1: raise Exception("Error on issue mask list")
\talist = json.loads(rv[0]["alist"])
\talarmfilter = " ( false "
\tfor a in alarms:
\t\tif a in alist:
\t\t\tmask = alist[a]
\t\t\tif mask == 0: alarmfilter += " or alarm_type = 0 "
\t\t\telif mask == -1: alarmfilter += " or alarm_type > 0 "
\t\t\telse: alarmfilter += " or (alarm_type & %s) = %s " % (mask,mask)
\talarmfilter += " ) "
'		-- execute
	,'select  
		id,
        ctime,
		guid,
		scrollid,
		media_id,
		lane,
		direction,
		velocity,
		velocity - int0 as speedlimit,
		vehicle_length,
		number,
		validity,
		rect_left,
		rect_top,
		rect_right,
		rect_bottom,
		country,
		numtype,
		to_json(geodata) as geodata,
		lib.jstrbit(alarm_type,8,''mask.issue.type'',null) as alarmtypes
	from platear pt 
	where 
		{postchannelfilter} and 
		{numberfilter} and 
		{speedfilter} and 
		{alarmfilter} and 
		{__filter[filter]} 
		order by {__filter[order]} limit {__filter[limit]}
	'		-- template
	,'public.platear'			-- primary key relation
	,'scrollid'					-- primary key
	,'bigint'					-- pkey type
	,'desc'						-- pkey sort 
	,'Platear scrollable on scrollid desc')
;

insert into public.filterclass (class,returns,paramdef,exec,template,prel,pkey,ptype,pord,memo)values
	('listplatear_db' 				-- classname
	,'table ( 
		id bigint,
        ctime timestamptz,
		guid uuid,
		scrollid bigint,
		media_id bigint,
		lane integer,
		direction integer,
		velocity integer,
		speedlimit integer,
		vehicle_length integer,
		number text,
		validity integer,
		rect_left float8,
		rect_top float8,
		rect_right float8,
		rect_bottom float8,
		country integer,
		numtype integer,
		geodata json,
		alarmtypes json
	) '		-- return type
	,'{
		"postchannel": { "type":"json", "format":"{uuid:[int,],}" },
		"number": { "type":"string" },
		"distance": { "type":"int" },
		"alarms": { "type":"[string]" },
		"fromspeed": {"type":"int" },
		"tospeed": {"type":"int" }
	}'::json					-- parameter definition
	,E'
import re, json	
postchannelfilter = ""
if "postchannel" in locals():
\tfor _p, _c in postchannel.iteritems():
\t\tpostchannelfilter += " or ( pt.post_id = ''%s'' " % (_p)
\t\tpostchannelfilter += ("and pt.channel = any(array[" +",".join((str(__c) for __c in _c))+"]::int[])") if len(_c) > 0 else ""
\t\tpostchannelfilter += ") "
postchannelfilter = " ( false " + postchannelfilter + ") " if len(postchannelfilter) > 0 else " true "
if not "number" in locals() or not number or number == "":
\tnumberfilter = "true"
else:
\tregex=number
\tif "distance" in locals() and distance > 0:
\t\tnumberfilter = " lib.ilevenstein(pt.number,''%s'') <= %d " % (number,distance)
\telse:
\t\tif re.search("[\\[\\]\^\\$\\.\\+\\*\\?]",number):
\t\t\tregex = regex.replace("*",".*")
\t\t\tif not re.search("^\\^",regex): regex = "^"+regex
\t\t\tif not re.search("\\$$",regex): regex = regex+"$"
\t\t\tnumberfilter = " pt.number ~* ''%s'' " % (regex)
\t\telse:
\t\t\tnumberfilter = " pt.number = ''%s'' " % (number)
speedfilter = ""
if "fromspeed" in locals() and fromspeed and fromspeed >= 0: speedfilter += " and pt.velocity >= %d " % (fromspeed)
if "tospeed" in locals() and tospeed and tospeed >= 0: speedfilter += " and pt.velocity <= %d " % (tospeed)
speedfilter = "( true " + speedfilter + ") " if len(speedfilter) > 0 else " true "
if not "alarms" in locals() or not alarms or len(alarms) == 0:
\talarmfilter = " true "
else:
\trv = plpy.execute("select json_object_agg(name, value) as alist from ( select name, value from public.const_integer where section = ''mask.issue.type'' union all values (''_none'' , 0),(''_any'' , -1) )q",1)
\tif rv.nrows() < 1: raise Exception("Error on issue mask list")
\talist = json.loads(rv[0]["alist"])
\talarmfilter = " ( false "
\tfor a in alarms:
\t\tif a in alist:
\t\t\tmask = alist[a]
\t\t\tif mask == 0: alarmfilter += " or alarm_type = 0 "
\t\t\telif mask == -1: alarmfilter += " or alarm_type > 0 "
\t\t\telse: alarmfilter += " or (alarm_type & %s) = %s " % (mask,mask)
\talarmfilter += " ) "
'		-- execute
	,'select  
		id,
        ctime,
		guid,
		scrollid,
		media_id,
		lane,
		direction,
		velocity,
		velocity - int0 as speedlimit,
		vehicle_length,
		number,
		validity,
		rect_left,
		rect_top,
		rect_right,
		rect_bottom,
		country,
		numtype,
		to_json(geodata) as geodata,
		lib.jstrbit(alarm_type,8,''mask.issue.type'',null) as alarmtypes
	from platear pt 
	where 
		{postchannelfilter} and 
		{numberfilter} and 
		{speedfilter} and 
		{alarmfilter} and 
		{__filter[filter]} 
		order by {__filter[order]} limit {__filter[limit]}
	'		-- template
	,'public.platear'			-- primary key relation
	,'id'					-- primary key
	,'bigint'					-- pkey type
	,'asc'						-- pkey sort 
	,'Platear scrollable on id asc')
;


insert into public.filterclass (class,returns,paramdef,exec,template,prel,pkey,ptype,pord,memo)values
	('listplatear_dbrev' 				-- classname
	,'table ( 
		id bigint,
        ctime timestamptz,
		guid uuid,
		scrollid bigint,
		media_id bigint,
		lane integer,
		direction integer,
		velocity integer,
		speedlimit integer,
		vehicle_length integer,
		number text,
		validity integer,
		rect_left float8,
		rect_top float8,
		rect_right float8,
		rect_bottom float8,
		country integer,
		numtype integer,
		geodata json,
		alarmtypes json
	) '		-- return type
	,'{
		"postchannel": { "type":"json", "format":"{uuid:[int,],}" },
		"number": { "type":"string" },
		"distance": { "type":"int" },
		"alarms": { "type":"[string]" },
		"fromspeed": {"type":"int" },
		"tospeed": {"type":"int" }
	}'::json					-- parameter definition
	,E'
import re, json	
postchannelfilter = ""
if "postchannel" in locals():
\tfor _p, _c in postchannel.iteritems():
\t\tpostchannelfilter += " or ( pt.post_id = ''%s'' " % (_p)
\t\tpostchannelfilter += ("and pt.channel = any(array[" +",".join((str(__c) for __c in _c))+"]::int[])") if len(_c) > 0 else ""
\t\tpostchannelfilter += ") "
postchannelfilter = " ( false " + postchannelfilter + ") " if len(postchannelfilter) > 0 else " true "
if not "number" in locals() or not number or number == "":
\tnumberfilter = "true"
else:
\tregex=number
\tif "distance" in locals() and distance > 0:
\t\tnumberfilter = " lib.ilevenstein(pt.number,''%s'') <= %d " % (number,distance)
\telse:
\t\tif re.search("[\\[\\]\^\\$\\.\\+\\*\\?]",number):
\t\t\tregex = regex.replace("*",".*")
\t\t\tif not re.search("^\\^",regex): regex = "^"+regex
\t\t\tif not re.search("\\$$",regex): regex = regex+"$"
\t\t\tnumberfilter = " pt.number ~* ''%s'' " % (regex)
\t\telse:
\t\t\tnumberfilter = " pt.number = ''%s'' " % (number)
speedfilter = ""
if "fromspeed" in locals() and fromspeed and fromspeed >= 0: speedfilter += " and pt.velocity >= %d " % (fromspeed)
if "tospeed" in locals() and tospeed and tospeed >= 0: speedfilter += " and pt.velocity <= %d " % (tospeed)
speedfilter = "( true " + speedfilter + ") " if len(speedfilter) > 0 else " true "
if not "alarms" in locals() or not alarms or len(alarms) == 0:
\talarmfilter = " true "
else:
\trv = plpy.execute("select json_object_agg(name, value) as alist from ( select name, value from public.const_integer where section = ''mask.issue.type'' union all values (''_none'' , 0),(''_any'' , -1) )q",1)
\tif rv.nrows() < 1: raise Exception("Error on issue mask list")
\talist = json.loads(rv[0]["alist"])
\talarmfilter = " ( false "
\tfor a in alarms:
\t\tif a in alist:
\t\t\tmask = alist[a]
\t\t\tif mask == 0: alarmfilter += " or alarm_type = 0 "
\t\t\telif mask == -1: alarmfilter += " or alarm_type > 0 "
\t\t\telse: alarmfilter += " or (alarm_type & %s) = %s " % (mask,mask)
\talarmfilter += " ) "
'		-- execute
	,'select  
		id,
        ctime,
		guid,
		scrollid,
		media_id,
		lane,
		direction,
		velocity,
		velocity - int0 as speedlimit,
		vehicle_length,
		number,
		validity,
		rect_left,
		rect_top,
		rect_right,
		rect_bottom,
		country,
		numtype,
		to_json(geodata) as geodata,
		lib.jstrbit(alarm_type,8,''mask.issue.type'',null) as alarmtypes
	from platear pt 
	where 
		{postchannelfilter} and 
		{numberfilter} and 
		{speedfilter} and 
		{alarmfilter} and 
		{__filter[filter]} 
		order by {__filter[order]} limit {__filter[limit]}
	'		-- template
	,'public.platear'			-- primary key relation
	,'id'					-- primary key
	,'bigint'					-- pkey type
	,'desc'						-- pkey sort 
	,'Platear scrollable on id desc')
;
