-- update script for X.X core patch XXXX


do language plpgsql
$_$
declare 
r record;
frommajor 	integer := 2;	-- points to source version
fromminor  	integer := 2;	-- if null then source = destination - (0,0,1)
fromrelease 	integer := 7;	-- optional

tomajor		integer	:= 3;		-- points to destination version
tominor		integer := 0;		-- mandatory
torelease	integer	:= 0;

torevision  varchar := '201606221800';	-- any string (i.e. timestamp)

begin

if not exists (select * from information_schema.columns where table_schema = 'core' and table_name = 'version' and column_name = 'release') then return; end if;
if tomajor isnull or tominor isnull or torelease isnull then raise exception 'Invalid upper version'; return; end if;	
if frommajor isnull or fromminor isnull or fromrelease isnull then frommajor := 0; fromminor := 0; fromrelease := 1; end if;	

select into r
	major,minor,release,
	lib.intversion(major,minor,release) as curver, 
	lib.intversion(frommajor,fromminor,fromrelease) as fromver, 
	lib.intversion(tomajor,tominor,torelease) as tover,
    exists ( select 1 from core.version where revision = torevision limit 1) as dup
from core.version where module = 'core' order by curver desc limit 1;
if not found then return; end if;

if r.curver > r.fromver and r.curver < r.tover and not r.dup then

-- BEGIN PATCH
ALTER TABLE platear
   ALTER COLUMN numtype SET DEFAULT -1;
ALTER TABLE platear
   ALTER COLUMN numtype SET NOT NULL;

ALTER TABLE platear
   ALTER COLUMN country SET DEFAULT -1;
ALTER TABLE platear
   ALTER COLUMN country SET NOT NULL;
   
ALTER TABLE platear
  ADD COLUMN county integer NOT NULL DEFAULT -1;



create or replace function service._convert_meta_store_001( iroot text, oroot text, idepth integer ) returns void as $$
import os
try:
	from bsddb import db
except ImportError:
	from bsddb3 import db

def _dirpass( idir, depth ):
    if depth > 0:
        for f in os.listdir(os.path.join(iroot,idir)):
            if f.startswith('.'): continue
            if f.startswith('__'): continue
            if os.path.isdir(os.path.join(iroot,idir, f)):
                _dirpass(os.path.join(idir, f), depth-1)
    else:
        opath = os.path.join(oroot, idir)
        mdir, mblock = os.path.split(opath)
        mdb = db.DB()
        mdb.open(os.path.join(mdir,".%s..meta"%(mblock)), dbtype=db.DB_BTREE, flags=db.DB_CREATE )
        for f in os.listdir(os.path.join(iroot,idir)):
            if f.startswith('.'): continue
            if f.startswith('__'): continue
            if os.path.isfile(os.path.join(iroot,idir,f)):
                with open(os.path.join(iroot,idir,f), mode='r') as fd:
                    fdata = fd.read()
                    mdb.put(f,fdata)
        mdb.close()            

_dirpass('',idepth)

$$ language plpythonu;


for r in 
select 
    s1.name as n1, 
    s1.root as r1, 
    s2.name as n2, 
    s2.root as r2,  
    json_array_length(json(s2.opt)) as d
from binfs.store s1 join binfs.store s2 on s2.name = 'META..'||s1.name loop
    
    perform service._convert_meta_store_001( r.r2, r.r1, r.d );
    perform binfs._remove(r.n2);
    
end loop;



drop function if exists service._convert_meta_store_001(  text,  text, integer );


alter table platear alter direction set default 0;
alter table platear alter direction set not null;
alter table platear alter "number" drop not null;
alter table platear alter post_id set not null;
alter table platear alter channel set default 0;
alter table platear alter channel set not null;

-- END PATCH


	insert into core.version (module,major,minor,release,revision) values('core',r.major,r.minor,r.release,torevision);
end if;
end;
$_$;

